

#include <ESP8266WiFi.h>
#include <PubSubClient.h>
#include <SPI.h>

#include <Adafruit_GFX.h>
#include <Adafruit_ILI9341.h>
 
#define TFT_CS D0  //for D1 mini or TFT I2C Connector Shield (V1.1.0 or later)
#define TFT_DC D8  //for D1 mini or TFT I2C Connector Shield (V1.1.0 or later)
#define TFT_RST -1 //for D1 mini or TFT I2C Connector Shield (V1.1.0 or later)
#define TS_CS D3   //for D1 mini or TFT I2C Connector Shield (V1.1.0 or later)
 
Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC, TFT_RST);
 
// These are 'flexible' lines that can be changed
float old=0;
float old2=0;
float old3=0;


#define LTBLUE    0xB6DF
#define LTTEAL    0xBF5F
#define LTGREEN   0xBFF7
#define LTCYAN    0xC7FF
#define LTRED     0xFD34
#define LTMAGENTA 0xFD5F
#define LTYELLOW  0xFFF8
#define LTORANGE  0xFE73
#define LTPINK    0xFDDF
#define LTPURPLE  0xCCFF
#define LTGREY    0xE71C

#define BLUE      0x001F
#define TEAL      0x0438
#define GREEN     0x07E0
#define CYAN      0x07FF
#define RED       0xF800
#define MAGENTA   0xF81F
#define YELLOW    0xFFE0
#define ORANGE    0xFC00
#define PINK      0xF81F
#define PURPLE    0x8010
#define GREY      0xC618
#define WHITE     0xFFFF
#define BLACK     0x0000

#define DKBLUE    0x000D
#define DKTEAL    0x020C
#define DKGREEN   0x03E0
#define DKCYAN    0x03EF
#define DKRED     0x6000
#define DKMAGENTA 0x8008
#define DKYELLOW  0x8400
#define DKORANGE  0x8200
#define DKPINK    0x9009
#define DKPURPLE  0x4010
#define DKGREY    0x4A49


#define ADJ_PIN A0
String inString = ""; 
String inStringb = ""; 
String inString2 = "";
String inString2b = ""; 
String inString3 = ""; 
String inString3b = ""; 
String inString4 = "";
String inString4b = ""; 
String inString5 = ""; 
String inString5b = ""; 

 int scan =0 ;
uint32_t runTime = -99999;       // time for next update
uint32_t runTime2 = -99999;
String input1 ="/invert";
//String input2 ="/temp/28ff48a470165ae";
String input2 = "weather/outTemp_C";
String input3 ="/humip";
String input4 ="/wind";
String input5 ="/grid";


// Update these with values suitable for your network.

const char* ssid = "internet";
const char* password = "";
const char* mqtt_server = "192.168.168.150";

WiFiClient espClient20;
PubSubClient client(espClient20);
long lastMsg = 0;
char msg[50];
int value = 0;

/*
//Adafruit_HX8357 tft = Adafruit_HX8357(TFT_CS, TFT_DC);
float ltx = 0;    // Saved x coord of bottom of needle
//uint16_t osx = M_SIZE*120, osy = M_SIZE*120; // Saved x & y coords
uint32_t updateTime = 0;       // time for next update

int old_analog =  -999; // Value last displayed
*/
//int value[6] = {0, 0, 0, 0, 0, 0};
//int old_value[6] = { -1, -1, -1, -1, -1, -1};
int d = 0;
// this is the only external variable used by the graph
// it's a flat to draw the coordinate system only on the first pass
boolean display1 = true;
boolean display2 = true;
boolean display3 = true;
boolean display4 = true;
boolean display5 = true;
boolean display6 = true;
boolean display7 = true;
boolean display8 = true;
boolean display9 = true;
boolean redraw1 = true;
double ox2 , oy2 ;
  double x, y;
double a1, b1, c1, d1, r2, r1, vo, tempC, tempF, tempK;
  
void setup() {

  Serial.begin(115000);

  pinMode(ADJ_PIN, INPUT);
  tft.begin();
  tft.setRotation(2);
  tft.fillScreen(BLACK);
setup_wifi();
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
  //tft.setRotation(2);
 


  //double x, y;


 // tft.setRotation(0);
/*

  for (x = 0; x <= 6.3; x += .1) {

    y = sin(x);
    Graph(tft, x, y, 60, 200, 220, 160, 0, 6.5, 1, -1, 1, .25, "Sin Function", "x", "sin(x)", DKBLUE, RED, YELLOW, WHITE, BLACK, display1);

  }

  delay(10000);

  tft.fillScreen(BLACK);
  for (x = 0; x <= 6.3; x += .1) {

    y = sin(x);
    Graph(tft, x, y, 100, 200, 100, 160, 0, 6.5, 3.25, -1, 1, .25, "Sin Function", "x", "sin(x)", GREY, GREEN, RED, YELLOW, BLACK, display9);

  }

    delay(10000);

  tft.fillScreen(BLACK);
  for (x = 0; x <= 25.2; x += .1) {

    y = sin(x);
    Graph(tft, x, y, 50, 190, 240, 60, 0, 25, 5, -1, 1, .5, "Sin Function", "x", "sin(x)", DKYELLOW, YELLOW, GREEN, WHITE, BLACK, display8);

  }

  delay(10000);

  tft.fillScreen(BLACK);
  for (x = 0.001; x <= 10; x += .1) {

    y = log(x);
    Graph(tft, x, y, 50, 200, 240, 160, 0, 10, 1, -10, 5, 1, "Natural Log Function", "x", "ln(x)", BLUE, RED, WHITE, WHITE, BLACK, display2);

  }

  

  delay(10000);
  tft.fillScreen(BLACK);

  for (x = 0; x <= 10; x += 1) {

    y = x * x;
    Graph(tft, x, y, 50, 200, 240, 160, 0, 10, 1, 0, 100, 10, "Square Function", "x", "x^2", DKRED, RED, YELLOW, WHITE, BLACK, display3);

  }

  delay(10000);
  tft.fillScreen(BLACK);

  for (x = 0.00; x <= 20; x += .01) {

    y = ((sin(x)) * x + cos(x)) - log(x);
    Graph(tft, x, y, 50, 200, 240, 160, 0, 20, 1, -20, 20, 5, "Weird Function", "x", " y = sin(x) + cos(x) - log(x)", ORANGE, YELLOW, CYAN, WHITE, BLACK, display4);

  }

  delay(10000);
  tft.fillScreen(BLACK);
  tft.setRotation(2);
  for (x = 0; x <= 12.6; x += .1) {

    y = sin(x);
    Graph(tft, x, y, 50, 200, 150, 150, 0, 13, 3.5, -1, 1, 1, "Sin(x)", "x", "sin(x)", DKBLUE, RED, YELLOW, WHITE, BLACK, display5);

  }
  tft.setRotation(3);
  delay(1000);
  tft.fillScreen(WHITE);

  for (x = 0; x <= 6.3; x += .05) {

    y = cos(x);
    Graph(tft, x, y, 100, 200, 240, 160, 0, 6.5, 3.25, -1, 1, 1, "Cos Function", "x", "cos(x)", DKGREY, GREEN, BLUE, BLACK, WHITE, display6);

  }

  delay(10000);
  tft.fillScreen(BLACK);
*/
/*
  for (x = 0; x <= 60; x += 1) {
    vo = analogRead(ADJ_PIN) / 204.6;
    r1 = 9940;
    r2 = ( vo * r1) / (5 - vo);

    //equation from data sheet
    tempK = 1.0 / (a1 + (b1 * (log(r2 / 10000.0))) + (c1 * pow(log(r2 / 10000.0), 2)) + (d1 * pow(log(r2 / 10000.0), 3)));
   
    tempC  = ((tempK - 273.15) );
    y = tempF  = (tempC * 1.8000) + 32.00;

    Graph(tft, x, y, 50, 200, 240, 150, 0, 60, 10, 70, 90, 5, "Room Temperature", " Time [s]", "Temperature [deg F]", DKBLUE, RED, GREEN, WHITE, BLACK, display7);
    delay(250);
    scan=0;
}

 delay(1000);
  tft.fillScreen(BLACK);
*/
}

void setup_wifi() {

  delay(10);
  // We start by connecting to a WiFi network
  Serial.println();
  tft.setCursor(0, 0);
  tft.setTextColor(CYAN);// tft.setTextSize(3);
  tft.println("Connecting to ");
  tft.println(ssid);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");
  tft.setCursor(0, 30);
  tft.setTextColor(BLUE);// tft.setTextSize(3);
  tft.println("IP address: ");
  tft.println(WiFi.localIP());
  
  
}

void callback(char* topic, byte* payload, unsigned int length) {
  scan++;
   if (input1 == topic){
  inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
  }
if (input2 == topic){
 inString2 = "";
 //scan++;
  for (int i=0;i<length;i++) {
     inString2 +=  ((char)payload[i]);  
  }
} 
 if (input3 == topic){
  inString3 = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString3 +=  ((char)payload[i]);
  }
  }
if (input4 == topic){
 inString4 = "";
  for (int i=0;i<length;i++) {
     inString4 +=  ((char)payload[i]);  
  }
} 
if (input5 == topic){
 inString5 = "";
  for (int i=0;i<length;i++) {
     inString5 +=  ((char)payload[i]);  
  }
} 



//if (scan < 30){
//if (millis() - runTime >= 2000L) { // Execute every 2s
    //runTime = millis();
  x= scan;
    /* for (x = 0; x <= 60; x += 1) {
    vo = 500 / 204.6;
    r1 = 9940;
    r2 = ( vo * r1) / (5 - vo);

    //equation from data sheet
    tempK = 1.0 / (a1 + (b1 * (log(r2 / 10000.0))) + (c1 * pow(log(r2 / 10000.0), 2)) + (d1 * pow(log(r2 / 10000.0), 3)));
    */
    tempC  = inString5.toFloat();
    Serial.println(tempC);
    y = tempC/1000 ; //= //(tempC * 1.8000) + 32.00;
    double Tinc = 60;
    Tinc = (Tinc*2);
    double Time= 360;
Time = Time*2;
    Graph(tft, x, y, 40, 180, 160, 150, 0, Time, Tinc, -0,12, 2, "Usage", " Time [s]", "Kilowatts", DKBLUE, RED, GREEN, WHITE, BLACK, display7);
   y=inString2.toFloat();
   //Graph(tft, x, y, 50, 200, 240, 150, 0, Time, Tinc, -25, 40, 5, "Outside Temperature", " Time [s]", "Temperature [deg C]", DKBLUE, RED, GREEN, WHITE, BLACK, display6);
  tft.setCursor(0, 220);
  tft.setTextColor(ILI9341_GREEN);
  tft.setTextSize(3);
  tft.print("GRID       kW" );
  tft.setCursor(110, 220);
    tft.setTextColor(ILI9341_BLACK);
  //tft.setTextSize(2);
  tft.print(old);
  tft.setTextColor(ILI9341_GREEN);
  tft.setCursor(110, 220);
  tft.print(inString5.toFloat()/1000);
   old=inString5.toFloat()/1000 ;
    tft.setCursor(0, 250);
  tft.setTextColor(ILI9341_YELLOW);
  tft.setTextSize(3);
  tft.print("SOLAR      kW" ); 
    tft.setCursor(110, 250);
    tft.setTextColor(ILI9341_BLACK);
  //tft.setTextSize(2);
  tft.print(old2);
  tft.setTextColor(ILI9341_YELLOW);
  tft.setCursor(110, 250);
  tft.print(inString4.toFloat()/1000);
   old2=inString4.toFloat()/1000 ;
  tft.setCursor(0, 280); 
    tft.setTextColor(ILI9341_WHITE);
  tft.setTextSize(3);
  tft.print("TOTAL      kW" ); 
      tft.setCursor(110, 280);
    tft.setTextColor(ILI9341_BLACK);
  //tft.setTextSize(2);
  tft.print(old3);
  tft.setTextColor(ILI9341_WHITE);
  tft.setCursor(110, 280);
  tft.print((inString5.toFloat()+inString4.toFloat())/1000);
   old3=(inString5.toFloat()+inString4.toFloat())/1000 ;
    //delay(250);
    //timE=90000* (timE/60);
 // }
 
if (millis() - runTime >= (60000 *(Time/60)*.6666666)) //{//(100000 * (Time/60)*.6666666)){
  {
  runTime=millis();
 //delay(1000);
 tft.fillScreen(BLACK);
  scan=0;
 /*  a1 = 3.354016E-03 ;
  b1 = 2.569850E-04 ;
  c1 = 2.620131E-06 ;
  d1 = 6.383091E-08 ;*/
  redraw1=true;
}
/*scan =0;
 * }
    // Test with a slowly changing value from a Sine function
    d += 5; if (d >= 360) d = 0;

    // Set the the position, gap between meters, and inner radius of the meters
    int xpos = 0, ypos = 5, gap = 4, radius = 52;

    // Draw meter and get back x position of next meter

    // Test with Sine wave function, normally reading will be from a sensor
    reading = ((inString.toInt())*2);
    xpos = gap + ringMeter(reading, 0, 2000, xpos, ypos, radius, "HP", GREEN2GREEN); // Draw analogue meter

    reading = (inString2.toInt());
    //reading = -17;
    xpos = gap + ringMeter(reading, -40, 50, xpos, ypos, radius, "degC", BLUE2RED); // Draw analogue meter

    reading = (inString3.toInt());
    //reading = 50;
    ringMeter(reading, 0, 100, xpos, ypos, radius, "%RH", BLUE2BLUE); // Draw analogue meter


    // Draw two more larger meters
    xpos = 20, ypos = 115, gap = 24, radius = 64;

    reading = (inString4.toInt());
    xpos = gap + ringMeter(reading, 0, 3000, xpos, ypos, radius, "SOLAR", RED2GREEN); // Draw analogue meter

    reading = (inString5.toInt());
    xpos = gap + ringMeter(reading, 0, 15000, xpos, ypos, radius, "GRID", GREEN2RED); // Draw analogue meter

    // Draw a large meter
    xpos = 40, ypos = 5, gap = 15, radius = 120;
    reading = 175;
    // Comment out above meters, then uncomment the next line to show large meter
    //ringMeter(reading,0,200, xpos,ypos,radius," Watts",GREEN2RED); // Draw analogue meter
*/
  //}


  // Switch on the LED if an 1 was received as first character
  if ((char)payload[0] == '1') {
    digitalWrite(BUILTIN_LED, LOW);   // Turn the LED on (Note that LOW is the voltage level
    // but actually the LED is on; this is because
    // it is acive low on the ESP-01)
  } else {
    digitalWrite(BUILTIN_LED, HIGH);  // Turn the LED off by making the voltage HIGH
  }

}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    tft.setCursor(0, 50);
   tft.setTextColor(RED); //tft.setTextSize(3);
   tft.println("Attempting MQTT ...");
    // Attempt to connect
    if (client.connect("ESP8266Clientsmall")) {
     tft.setTextColor(GREEN);// tft.setTextSize(3);
     tft.println("connected");
      
      // Once connected, publish an announcement...
      client.publish("outTopic", "hello world");
      // ... and resubscribe
      client.subscribe("/grid");
      client.subscribe("/wind");
      client.subscribe("/temp/28ff48a470165ae");
      client.subscribe("/invert");
      client.subscribe("/humid");
      
      delay(3000);
      tft.fillScreen(BLACK);
    } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}

void loop(void) {

   if (!client.connected()) {
    reconnect();
  }
  client.loop();
 /* 
 if (updateTime <= millis()) {
    updateTime = millis() + 35; // Update emter every 35 milliseconds
 
    // Create a Sine wave for testing
    d += 4; if (d >= 360) d = 0;
    value[0] = 50 + 50 * sin((d + 0) * 0.0174532925);
 
 //   plotNeedle(value[0], 0); // It takes between 2 and 12ms to replot the needle with zero delay
  }*/
}

/*

  function to draw a cartesian coordinate system and plot whatever data you want
  just pass x and y and the graph will be drawn

  huge arguement list
  &d name of your display object
  x = x data point
  y = y datapont
  gx = x graph location (lower left)
  gy = y graph location (lower left)
  w = width of graph
  h = height of graph
  xlo = lower bound of x axis
  xhi = upper bound of x asis
  xinc = division of x axis (distance not count)
  ylo = lower bound of y axis
  yhi = upper bound of y asis
  yinc = division of y axis (distance not count)
  title = title of graph
  xlabel = x asis label
  ylabel = y asis label
  gcolor = graph line colors
  acolor = axi ine colors
  pcolor = color of your plotted data
  tcolor = text color
  bcolor = background color
  &redraw = flag to redraw graph on fist call only
*/


void Graph(Adafruit_ILI9341 &d, double x, double y, double gx, double gy, double w, double h, double xlo, double xhi, double xinc, double ylo, double yhi, double yinc, String title, String xlabel, String ylabel, unsigned int gcolor, unsigned int acolor, unsigned int pcolor, unsigned int tcolor, unsigned int bcolor, boolean &redraw) {
if (redraw1==true){redraw=true;}
//xhi =xhi*.66;
redraw1=false;
  double ydiv, xdiv;
  // initialize old x and old y in order to draw the first point of the graph
  // but save the transformed value
  // note my transform funcition is the same as the map function, except the map uses long and we need doubles
  //static double ox = (x - xlo) * ( w) / (xhi - xlo) + gx;
  //static double oy = (y - ylo) * (gy - h - gy) / (yhi - ylo) + gy;
  double i;
  double temp;
  int rot, newrot;

  if (redraw == true) {

    redraw = false;
    ox2 = (x - xlo) * ( w) / (xhi - xlo) + gx;
    oy2 = (y - ylo) * (gy - h - gy) / (yhi - ylo) + gy;
    // draw y scale
    for ( i = ylo; i <= yhi; i += yinc) {
      // compute the transform
      temp =  (i - ylo) * (gy - h - gy) / (yhi - ylo) + gy;

      if (i == 0) {
        d.drawLine(gx, temp, gx + w, temp, acolor);
      }
      else {
        d.drawLine(gx, temp, gx + w, temp, gcolor);
      }

      d.setTextSize(1);
      d.setTextColor(tcolor, bcolor);
      d.setCursor(gx - 40, temp);
      // precision is default Arduino--this could really use some format control
      int strip =i;
      d.println(strip);
    }
    // draw x scale
    for (i = xlo; i <= xhi; i += xinc) {

      // compute the transform

      temp =  (i - xlo) * ( w) / (xhi - xlo) + gx;
      if (i == 0) {
        d.drawLine(temp, gy, temp, gy - h, acolor);
      }
      else {
        d.drawLine(temp, gy, temp, gy - h, gcolor);
      }

      d.setTextSize(1);
      d.setTextColor(tcolor, bcolor);
      d.setCursor(temp, gy + 10);
      // precision is default Arduino--this could really use some format control
    int strip =i/2;
      d.println(strip);
    }

    //now draw the labels
    d.setTextSize(2);
    d.setTextColor(tcolor, bcolor);
    d.setCursor(gx , gy - h - 30);
    d.println(title);

    d.setTextSize(1);
    d.setTextColor(acolor, bcolor);
    d.setCursor(gx , gy + 20);
    d.println(xlabel);

    d.setTextSize(1);
    d.setTextColor(acolor, bcolor);
    d.setCursor(gx - 30, gy - h - 10);
    d.println(ylabel);


  }

  //graph drawn now plot the data
  // the entire plotting code are these few lines...
  // recall that ox and oy are initialized as static above
  x =  (x - xlo) * ( w) / (xhi - xlo) + gx;
  y =  (y - ylo) * (gy - h - gy) / (yhi - ylo) + gy;
  d.drawLine(ox2, oy2, x, y, pcolor);
  d.drawLine(ox2, oy2 + 1, x, y + 1, pcolor);
  d.drawLine(ox2, oy2 - 1, x, y - 1, pcolor);
  ox2 = x;
  oy2= y;

}

/*
  End of graphing functioin
*/


String Format(double val, int dec, int dig ) {
  int addpad = 0;
  char sbuf[20];
  String condata = (dtostrf(val, dec, dig, sbuf));


  int slen = condata.length();
  for ( addpad = 1; addpad <= dec + dig - slen; addpad++) {
    condata = " " + condata;
  }
  return (condata);

}
